function cse15_plot(o)
% cse15_plot (cse15 companion code)
% by Christian Himpe, 2015 ( http://wwwmath.uni-muenster.de/u/himpe )
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )
%*

if(nargin<1), o=0; end

load('l2.mat');

N = 64;
n = 8;

figure();
h = surf(k2g);
xlim([1,8]);
ylim([1,8]);
set(gca,'ZScale','log');
zlim([1e-3,1]);
set(gca,'XTick',1:8);
set(gca,'YTick',1:8);
set(gca,'XTickLabel',1:n:N);
set(gca,'YTickLabel',1:n:N);
ylabel('State Dimension')
xlabel('Parameter Dimension');
colormap(antijet);
set(h,'CData',log10(get(h,'CData')))
view(135,30);
pbaspect([1,1,2]);
if(o==1), print('-depsc','forward_gramian.eps'); end;

figure();
h = surf(l2g);
xlim([1,8]);
ylim([1,8]);
set(gca,'ZScale','log');
zlim([1e-3,1]);
set(gca,'XTick',1:8);
set(gca,'YTick',1:8);
set(gca,'XTickLabel',1:n:N);
set(gca,'YTickLabel',1:n:N);
ylabel('State Dimension')
xlabel('Parameter Dimension');
colormap(antijet);
set(h,'CData',log10(get(h,'CData')))
view(135,30);
pbaspect([1,1,2]);
if(o==1), print('-depsc','inverse_gramian.eps'); end;

figure();
h = surf(k2o);
xlim([1,8]);
ylim([1,8]);
set(gca,'ZScale','log');
zlim([1e-3,1]);
set(gca,'XTick',1:8);
set(gca,'YTick',1:8);
set(gca,'XTickLabel',1:n:N);
set(gca,'YTickLabel',1:n:N);
ylabel('State Dimension')
xlabel('Parameter Dimension');
colormap(antijet);
set(h,'CData',log10(get(h,'CData')))
view(135,30);
pbaspect([1,1,2]);
if(o==1), print('-depsc','forward_optim.eps'); end;

figure();
h = surf(l2o);
xlim([1,8]);
ylim([1,8]);
set(gca,'ZScale','log');
zlim([1e-3,1]);
set(gca,'XTick',1:8);
set(gca,'YTick',1:8);
set(gca,'XTickLabel',1:n:N);
set(gca,'YTickLabel',1:n:N);
ylabel('State Dimension')
xlabel('Parameter Dimension');
colormap(antijet);
set(h,'CData',log10(get(h,'CData')))
view(135,30);
pbaspect([1,1,2]);
if(o==1), print('-depsc','inverse_optim.eps'); end;


%% ======== Colormap ========

function m = antijet(n)
% antijet colormap
% by Christian Himpe 2014
% released under BSD 2-Clause License ( opensource.org/licenses/BSD-2-Clause )

if(nargin<1 || isempty(n)), n = 256; end;
L = linspace(0,1,n);

R = -0.5*sin( L*(1.37*pi)+0.13*pi )+0.5;
G = -0.4*cos( L*(1.5*pi) )+0.4;
B = 0.3*sin( L*(2.11*pi) )+0.3;

m = [R;G;B]';
